#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

void formatFasta (FILE *in, FILE *out, FILE *names)
{
	char c;
	bool first = true;
	int i = 0, j = 0;
	while (1)
	{
		c = getc (in);
		if (c == '>')
		{
			if (!first)
			{
				fprintf (names, "\t%d\n", j);
				fputc ('\n', out);
			}
			fprintf (out, "> %d", i);
			fprintf (names, "%d\t", i++);
			j = 0;
			first = false;
			for (c = getc (in); c != '\n'; c = getc (in))
				if (c == EOF)
				{
					fprintf (names, "\t%d\n", j);
					return;
				}
				else if (c != '\t')
					fputc (c, names);
		}
		if (c == EOF)
		{
			fprintf (names, "\t%d\n", j);
			return;
		}
		if (c != ' ' && c != '\t' && c != '\n')
		{
			first = false;
			if (j % 80 == 0)
				fputc ('\n', out);
			fputc ((char)toupper(c), out);
			j++;
		}
	}
}

void main (int argc, char* argv[])
{
	FILE *in, *out, *names;
	char c, outFile[300];
	int i;
	if (argc != 2)
	{
		printf ("Usage %s <filename>\n", argv[0]);
		exit(0);
	}
	in = fopen (argv[1], "r");
	if (in == NULL)
	{
		printf ("File %s not found\n", argv[1]);
		exit(0);
	}
	strcpy (outFile, argv[1]);
	strcat (outFile, ".formated");
	out = fopen (outFile, "w");
	strcpy (outFile, argv[1]);
	strcat (outFile, ".names");
	names = fopen (outFile, "w");
	formatFasta (in, out, names);
	fclose (in);
	fclose (out);
	fclose (names);
}

